<html>
<head>
<title>OGRE: OgreRenderSystem.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreRenderSystem.h</h1><a href="OgreRenderSystem_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __RenderSystem_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __RenderSystem_H_</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreTextureUnitState_8h.html">OgreTextureUnitState.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#include "<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>"</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include "<a class="code" href="OgreRenderSystemCapabilities_8h.html">OgreRenderSystemCapabilities.h</a>"</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include "<a class="code" href="OgreRenderTarget_8h.html">OgreRenderTarget.h</a>"</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include "<a class="code" href="OgreRenderTexture_8h.html">OgreRenderTexture.h</a>"</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include "<a class="code" href="OgreFrameListener_8h.html">OgreFrameListener.h</a>"</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include "<a class="code" href="OgreConfigOptionMap_8h.html">OgreConfigOptionMap.h</a>"</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include "<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>"</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include "<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>"</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="keyword">namespace </span>Ogre
<a name="l00051"></a>00051 {
<a name="l00052"></a><a class="code" href="namespaceOgre.html#2551e2d3573c437f3beccf7d3ac7a45e">00052</a>     <span class="keyword">typedef</span> std::map&lt; String, RenderTarget * &gt; <a class="code" href="namespaceOgre.html#2551e2d3573c437f3beccf7d3ac7a45e">RenderTargetMap</a>;
<a name="l00053"></a><a class="code" href="namespaceOgre.html#eacbf68563f1c1e5660c4399d398608c">00053</a>     <span class="keyword">typedef</span> std::multimap&lt;uchar, RenderTarget * &gt; <a class="code" href="namespaceOgre.html#eacbf68563f1c1e5660c4399d398608c">RenderTargetPriorityMap</a>;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     <span class="keyword">class </span><a class="code" href="classOgre_1_1TextureManager.html" title="Class for loading &amp;amp; managing textures.">TextureManager</a>;
<a name="l00057"></a><a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31">00057</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31" title="Enum describing the ways to generate texture coordinates.">TexCoordCalcMethod</a>
<a name="l00058"></a>00058     {
<a name="l00060"></a><a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb3173546a8946a02a34d7958763e0c1034e">00060</a>         <a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb3173546a8946a02a34d7958763e0c1034e" title="No calculated texture coordinates.">TEXCALC_NONE</a>,
<a name="l00062"></a><a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31414edb1748a8b2bfd8c4699164c46352">00062</a>         <a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31414edb1748a8b2bfd8c4699164c46352" title="Environment map based on vertex normals.">TEXCALC_ENVIRONMENT_MAP</a>,
<a name="l00064"></a><a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31516f97319ea6e8a02daef9f13c32303c">00064</a>         <a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31516f97319ea6e8a02daef9f13c32303c" title="Environment map based on vertex positions.">TEXCALC_ENVIRONMENT_MAP_PLANAR</a>,
<a name="l00065"></a><a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31d4c1a576294c5fc8a0519783fc9e2eab">00065</a>         <a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31d4c1a576294c5fc8a0519783fc9e2eab">TEXCALC_ENVIRONMENT_MAP_REFLECTION</a>,
<a name="l00066"></a><a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31a296599db57208482d35f5d264d61578">00066</a>         <a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31a296599db57208482d35f5d264d61578">TEXCALC_ENVIRONMENT_MAP_NORMAL</a>,
<a name="l00068"></a><a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31bcbba9b2c16dc5c57c479dfc486095db">00068</a>         <a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31bcbba9b2c16dc5c57c479dfc486095db" title="Projective texture.">TEXCALC_PROJECTIVE_TEXTURE</a>
<a name="l00069"></a>00069     };
<a name="l00071"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61">00071</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a>
<a name="l00072"></a>00072     {
<a name="l00074"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61bf640cb28b5020509dc27178f0359511">00074</a>         <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61bf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l00076"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61910e7fedb6c873aaad581cfda6491b8a">00076</a>         <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61910e7fedb6c873aaad581cfda6491b8a" title="Set the stencil value to zero.">SOP_ZERO</a>,
<a name="l00078"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61cbce9e054c373718a59dd56e51aa762a">00078</a>         <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61cbce9e054c373718a59dd56e51aa762a" title="Set the stencil value to the reference value.">SOP_REPLACE</a>,
<a name="l00080"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61e56b6038f9552a79b2b1d2ae036da86c">00080</a>         <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61e56b6038f9552a79b2b1d2ae036da86c" title="Increase the stencil value by 1, clamping at the maximum value.">SOP_INCREMENT</a>,
<a name="l00082"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb617faeb919637b85bed8650d8f1baf2ada">00082</a>         <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb617faeb919637b85bed8650d8f1baf2ada" title="Decrease the stencil value by 1, clamping at 0.">SOP_DECREMENT</a>,
<a name="l00084"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb616e595fbb31308c6b01f35221903f4706">00084</a>         <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb616e595fbb31308c6b01f35221903f4706" title="Increase the stencil value by 1, wrapping back to 0 when incrementing the maximum...">SOP_INCREMENT_WRAP</a>,
<a name="l00086"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61b816aeb027a4e517237d053e5fedc2a7">00086</a>         <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61b816aeb027a4e517237d053e5fedc2a7" title="Decrease the stencil value by 1, wrapping when decrementing 0.">SOP_DECREMENT_WRAP</a>,
<a name="l00088"></a><a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb614f9045fb414071aa89184ce5e88ec474">00088</a>         <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb614f9045fb414071aa89184ce5e88ec474" title="Invert the bits of the stencil buffer.">SOP_INVERT</a>
<a name="l00089"></a>00089     };
<a name="l00090"></a>00090 
<a name="l00114"></a><a class="code" href="classOgre_1_1RenderSystem.html">00114</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>
<a name="l00115"></a>00115     {
<a name="l00116"></a>00116     <span class="keyword">public</span>:
<a name="l00119"></a>00119         <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>();
<a name="l00120"></a>00120 
<a name="l00123"></a>00123         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>();
<a name="l00124"></a>00124 
<a name="l00127"></a>00127         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00128"></a>00128 
<a name="l00150"></a>00150         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#9f6262ba9e855a064430936555d0ba62">ConfigOptionMap</a>&amp; getConfigOptions(<span class="keywordtype">void</span>) = 0;
<a name="l00151"></a>00151 
<a name="l00171"></a>00171         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setConfigOption(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value) = 0;
<a name="l00172"></a>00172 
<a name="l00175"></a>00175         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for...">HardwareOcclusionQuery</a>* createHardwareOcclusionQuery(<span class="keywordtype">void</span>) = 0;
<a name="l00176"></a>00176 
<a name="l00179"></a>00179         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyHardwareOcclusionQuery(<a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for...">HardwareOcclusionQuery</a> *hq);
<a name="l00180"></a>00180 
<a name="l00185"></a>00185         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfigOptions(<span class="keywordtype">void</span>) = 0;
<a name="l00186"></a>00186 
<a name="l00203"></a>00203         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* initialise(<span class="keywordtype">bool</span> autoCreateWindow, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle = <span class="stringliteral">"OGRE Render Window"</span>);
<a name="l00204"></a>00204 
<a name="l00207"></a>00207         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reinitialise(<span class="keywordtype">void</span>) = 0;
<a name="l00208"></a>00208 
<a name="l00211"></a>00211         <span class="keyword">virtual</span> <span class="keywordtype">void</span> shutdown(<span class="keywordtype">void</span>);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00216"></a>00216         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAmbientLight(<span class="keywordtype">float</span> r, <span class="keywordtype">float</span> g, <span class="keywordtype">float</span> b) = 0;
<a name="l00217"></a>00217 
<a name="l00220"></a>00220         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setShadingType(<a class="code" href="namespaceOgre.html#7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> so) = 0;
<a name="l00221"></a>00221 
<a name="l00227"></a>00227         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setLightingEnabled(<span class="keywordtype">bool</span> enabled) = 0;
<a name="l00228"></a>00228 
<a name="l00235"></a>00235         <span class="keywordtype">void</span> setWBufferEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00236"></a>00236 
<a name="l00239"></a>00239         <span class="keywordtype">bool</span> getWBufferEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00240"></a>00240 
<a name="l00359"></a>00359         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* createRenderWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00360"></a>00360             <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a> *miscParams = 0) = 0;
<a name="l00361"></a>00361 
<a name="l00388"></a>00388         <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a> * createRenderTexture( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height,
<a name="l00389"></a>00389             <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> texType = <a class="code" href="namespaceOgre.html#e50520af6377ff8184cf79125cb9c4d7f1f732018f5a2a7d35233e2ceeb4ee0e" title="2D texture, used in combination with 2D texture coordinates (default)">TEX_TYPE_2D</a>, <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> internalFormat = <a class="code" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c2542d39f6712cb6f69907330a31a9342" title="32-bit pixel format, 8 bits for red, 8 bits for green, 8 bits for blue like PF_A8R8G8B8...">PF_X8R8G8B8</a>, 
<a name="l00390"></a>00390             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a> *miscParams = 0 ); 
<a name="l00391"></a>00391 
<a name="l00396"></a>00396         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at...">MultiRenderTarget</a> * createMultiRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name) = 0; 
<a name="l00397"></a>00397 
<a name="l00399"></a>00399         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyRenderWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00401"></a>00401         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyRenderTexture(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00403"></a>00403         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00404"></a>00404 
<a name="l00407"></a>00407         <span class="keyword">virtual</span> <span class="keywordtype">void</span> attachRenderTarget( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a> &amp;target );
<a name="l00411"></a>00411         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a> * getRenderTarget( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name );
<a name="l00417"></a>00417         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a> * detachRenderTarget( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name );
<a name="l00418"></a>00418 
<a name="l00420"></a><a class="code" href="classOgre_1_1RenderSystem.html#50a15a7bbc1beca5c91b6584a3060f1b">00420</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;Ogre::RenderTargetMap&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">RenderTargetIterator</a>;
<a name="l00421"></a>00421 
<a name="l00423"></a><a class="code" href="classOgre_1_1RenderSystem.html#2e8f34e7464302fbce845f1d3fd468c8">00423</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">RenderTargetIterator</a> getRenderTargetIterator(<span class="keywordtype">void</span>) {
<a name="l00424"></a>00424             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">RenderTargetIterator</a>( mRenderTargets.begin(), mRenderTargets.end() );
<a name="l00425"></a>00425         }
<a name="l00428"></a>00428         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getErrorDescription(<span class="keywordtype">long</span> errorNumber) <span class="keyword">const</span> = 0;
<a name="l00429"></a>00429 
<a name="l00443"></a>00443         <span class="keywordtype">void</span> setWaitForVerticalBlank(<span class="keywordtype">bool</span> enabled);
<a name="l00444"></a>00444 
<a name="l00447"></a>00447         <span class="keywordtype">bool</span> getWaitForVerticalBlank(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00448"></a>00448 
<a name="l00449"></a>00449         <span class="comment">// ------------------------------------------------------------------------</span>
<a name="l00450"></a>00450         <span class="comment">//                     Internal Rendering Access</span>
<a name="l00451"></a>00451         <span class="comment">// All methods below here are normally only called by other OGRE classes</span>
<a name="l00452"></a>00452         <span class="comment">// They can be called by library user if required</span>
<a name="l00453"></a>00453         <span class="comment">// ------------------------------------------------------------------------</span>
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00459"></a>00459         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _useLights(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a>&amp; lights, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> limit) = 0;
<a name="l00461"></a>00461         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setWorldMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> &amp;m) = 0;
<a name="l00463"></a>00463         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setWorldMatrices(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* m, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> count);
<a name="l00465"></a>00465         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setViewMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> &amp;m) = 0;
<a name="l00467"></a>00467         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> &amp;m) = 0;
<a name="l00473"></a>00473         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureUnitSettings(<span class="keywordtype">size_t</span> texUnit, <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>&amp; tl);
<a name="l00475"></a>00475         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _disableTextureUnit(<span class="keywordtype">size_t</span> texUnit);
<a name="l00477"></a>00477         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _disableTextureUnitsFrom(<span class="keywordtype">size_t</span> texUnit);
<a name="l00511"></a>00511         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setSurfaceParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;ambient,
<a name="l00512"></a>00512             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;diffuse, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;specular,
<a name="l00513"></a>00513             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;emissive, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> shininess,
<a name="l00514"></a>00514             <a class="code" href="namespaceOgre.html#f3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours...">TrackVertexColourType</a> tracking = <a class="code" href="namespaceOgre.html#5d04131dcb51ec3cf219465196b6de854b75431ccf4b6bde635265300498660e">TVC_NONE</a>) = 0;
<a name="l00515"></a>00515 
<a name="l00521"></a>00521         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setPointSpritesEnabled(<span class="keywordtype">bool</span> enabled) = 0;
<a name="l00522"></a>00522 
<a name="l00533"></a>00533         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setPointParameters(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> size, <span class="keywordtype">bool</span> attenuationEnabled, 
<a name="l00534"></a>00534             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> constant, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linear, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> quadratic, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> minSize, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> maxSize) = 0;
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 
<a name="l00549"></a>00549         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTexture(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">bool</span> enabled, 
<a name="l00550"></a>00550             <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> &amp;texPtr) = 0;
<a name="l00564"></a>00564         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTexture(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">bool</span> enabled, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;texname);
<a name="l00565"></a>00565 
<a name="l00575"></a>00575         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setVertexTexture(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; tex);
<a name="l00576"></a>00576 
<a name="l00586"></a>00586         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureCoordSet(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">size_t</span> index) = 0;
<a name="l00587"></a>00587 
<a name="l00595"></a>00595         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureCoordCalculation(<span class="keywordtype">size_t</span> unit, <a class="code" href="namespaceOgre.html#a9c06899edc6b7aed7bf3b29abe9bb31" title="Enum describing the ways to generate texture coordinates.">TexCoordCalcMethod</a> m, 
<a name="l00596"></a>00596             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent...">Frustum</a>* frustum = 0) = 0;
<a name="l00597"></a>00597 
<a name="l00604"></a>00604         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureBlendMode(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a>&amp; bm) = 0;
<a name="l00605"></a>00605 
<a name="l00612"></a>00612         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureUnitFiltering(<span class="keywordtype">size_t</span> unit, <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> minFilter,
<a name="l00613"></a>00613             <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> magFilter, <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> mipFilter);
<a name="l00614"></a>00614 
<a name="l00620"></a>00620         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureUnitFiltering(<span class="keywordtype">size_t</span> unit, <a class="code" href="namespaceOgre.html#c1fc36ec2f4df4b2afa9fa39f9c66c06">FilterType</a> ftype, <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> filter) = 0;
<a name="l00621"></a>00621 
<a name="l00623"></a>00623         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureLayerAnisotropy(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxAnisotropy) = 0;
<a name="l00624"></a>00624 
<a name="l00626"></a>00626         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureAddressingMode(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html" title="Texture addressing mode for each texture coordinate.">TextureUnitState::UVWAddressingMode</a>&amp; uvw) = 0;
<a name="l00627"></a>00627 
<a name="l00629"></a>00629         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureBorderColour(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour) = 0;
<a name="l00630"></a>00630 
<a name="l00639"></a>00639         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureMipmapBias(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">float</span> bias) = 0;
<a name="l00640"></a>00640 
<a name="l00645"></a>00645         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureMatrix(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; xform) = 0;
<a name="l00646"></a>00646 
<a name="l00655"></a>00655         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setSceneBlending(<a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor) = 0;
<a name="l00656"></a>00656 
<a name="l00662"></a>00662         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setAlphaRejectSettings(<a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> value) = 0;
<a name="l00667"></a>00667         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _beginFrame(<span class="keywordtype">void</span>) = 0;
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 
<a name="l00673"></a>00673         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _endFrame(<span class="keywordtype">void</span>) = 0;
<a name="l00681"></a>00681         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setViewport(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp) = 0;
<a name="l00683"></a>00683         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* _getViewport(<span class="keywordtype">void</span>);
<a name="l00684"></a>00684 
<a name="l00696"></a>00696         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setCullingMode(<a class="code" href="namespaceOgre.html#c173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mode) = 0;
<a name="l00697"></a>00697 
<a name="l00698"></a>00698         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#c173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> _getCullingMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00699"></a>00699 
<a name="l00713"></a>00713         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBufferParams(<span class="keywordtype">bool</span> depthTest = <span class="keyword">true</span>, <span class="keywordtype">bool</span> depthWrite = <span class="keyword">true</span>, <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> depthFunction = <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a>) = 0;
<a name="l00714"></a>00714 
<a name="l00719"></a>00719         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBufferCheckEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>) = 0;
<a name="l00724"></a>00724         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBufferWriteEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>) = 0;
<a name="l00732"></a>00732         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBufferFunction(<a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a>) = 0;
<a name="l00740"></a>00740         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setColourBufferWriteEnabled(<span class="keywordtype">bool</span> red, <span class="keywordtype">bool</span> green, <span class="keywordtype">bool</span> blue, <span class="keywordtype">bool</span> alpha) = 0;
<a name="l00763"></a>00763         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBias(<span class="keywordtype">float</span> constantBias, <span class="keywordtype">float</span> slopeScaleBias = 0.0f) = 0;
<a name="l00775"></a>00775         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setFog(<a class="code" href="namespaceOgre.html#83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mode = <a class="code" href="namespaceOgre.html#83edeb2e5d33a3ca8f15834ba40020bab7793a21880052c0214d4cc040992310" title="No fog. Duh.">FOG_NONE</a>, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> expDensity = 1.0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearStart = 0.0, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearEnd = 1.0) = 0;
<a name="l00776"></a>00776 
<a name="l00777"></a>00777 
<a name="l00779"></a>00779         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _beginGeometryCount(<span class="keywordtype">void</span>);
<a name="l00781"></a>00781         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getFaceCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00783"></a>00783         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getBatchCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00785"></a>00785         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getVertexCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00786"></a>00786 
<a name="l00795"></a>00795         <span class="keyword">virtual</span> <span class="keywordtype">void</span> convertColourValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour, <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>* pDest);
<a name="l00799"></a>00799         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> getColourVertexElementType(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00800"></a>00800 
<a name="l00807"></a>00807         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _convertProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; matrix,
<a name="l00808"></a>00808             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>) = 0;
<a name="l00809"></a>00809 
<a name="l00816"></a>00816         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _makeProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, 
<a name="l00817"></a>00817             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>) = 0;
<a name="l00818"></a>00818 
<a name="l00825"></a>00825         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _makeProjectionMatrix(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, 
<a name="l00826"></a>00826             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>) = 0;
<a name="l00833"></a>00833         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _makeOrthoMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, 
<a name="l00834"></a>00834             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>) = 0;
<a name="l00835"></a>00835 
<a name="l00852"></a>00852         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _applyObliqueDepthProjection(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>&amp; matrix, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane, 
<a name="l00853"></a>00853             <span class="keywordtype">bool</span> forGpuProgram) = 0;
<a name="l00854"></a>00854         
<a name="l00856"></a>00856         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setPolygonMode(<a class="code" href="namespaceOgre.html#68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> level) = 0;
<a name="l00857"></a>00857 
<a name="l00864"></a>00864         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setStencilCheckEnabled(<span class="keywordtype">bool</span> enabled) = 0;
<a name="l00880"></a>00880         <span class="comment">/*virtual bool hasHardwareStencil(void) = 0;*/</span>
<a name="l00881"></a>00881 
<a name="l00917"></a>00917         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setStencilBufferParams(<a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7ae10ea1648cd8c9bd90bdaccaa11cbc4e">CMPF_ALWAYS_PASS</a>, 
<a name="l00918"></a>00918             <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> refValue = 0, <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask = 0xFFFFFFFF, 
<a name="l00919"></a>00919             <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> stencilFailOp = <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61bf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>, 
<a name="l00920"></a>00920             <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> depthFailOp = <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61bf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l00921"></a>00921             <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> passOp = <a class="code" href="namespaceOgre.html#e8bb1cb809660de802d1d592ba4adb61bf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>, 
<a name="l00922"></a>00922             <span class="keywordtype">bool</span> twoSidedOperation = <span class="keyword">false</span>) = 0;
<a name="l00923"></a>00923 
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 
<a name="l00927"></a>00927         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVertexDeclaration(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a>* decl) = 0;
<a name="l00929"></a>00929         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVertexBufferBinding(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>* binding) = 0;
<a name="l00930"></a>00930 
<a name="l00941"></a>00941         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setNormaliseNormals(<span class="keywordtype">bool</span> normalise) = 0;
<a name="l00942"></a>00942 
<a name="l00955"></a>00955         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _render(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&amp;#39;New&amp;#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00956"></a>00956 
<a name="l00958"></a><a class="code" href="classOgre_1_1RenderSystem.html#1ea7609b7337a8b184c4348b09d5c46a">00958</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* getCapabilities(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCapabilities; }
<a name="l00959"></a>00959 
<a name="l00964"></a>00964         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindGpuProgram(<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* prg);
<a name="l00965"></a>00965 
<a name="l00968"></a>00968         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindGpuProgramParameters(<a class="code" href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> params) = 0;
<a name="l00971"></a>00971         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindGpuProgramPassIterationParameters(<a class="code" href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype) = 0;
<a name="l00976"></a>00976         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unbindGpuProgram(<a class="code" href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l00977"></a>00977         
<a name="l00979"></a>00979         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isGpuProgramBound(<a class="code" href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l00980"></a>00980 
<a name="l00983"></a>00983         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setClipPlanes(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a>&amp; clipPlanes) = 0;
<a name="l00984"></a>00984 
<a name="l00986"></a>00986         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _initRenderTargets(<span class="keywordtype">void</span>);
<a name="l00987"></a>00987 
<a name="l00991"></a>00991         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyCameraRemoved(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00992"></a>00992 
<a name="l00994"></a>00994         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateAllRenderTargets(<span class="keywordtype">void</span>);
<a name="l00995"></a>00995 
<a name="l00997"></a>00997         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setClipPlane (<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> &amp;p);
<a name="l00999"></a>00999         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setClipPlane (<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> index, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> A, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> B, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> C, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> D) = 0;
<a name="l01001"></a>01001         <span class="keyword">virtual</span> <span class="keywordtype">void</span> enableClipPlane (<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> index, <span class="keywordtype">bool</span> enable) = 0;
<a name="l01002"></a>01002 
<a name="l01005"></a>01005         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInvertVertexWinding(<span class="keywordtype">bool</span> invert);
<a name="l01017"></a>01017         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setScissorTest(<span class="keywordtype">bool</span> enabled, <span class="keywordtype">size_t</span> left = 0, <span class="keywordtype">size_t</span> top = 0, 
<a name="l01018"></a>01018             <span class="keywordtype">size_t</span> right = 800, <span class="keywordtype">size_t</span> bottom = 600) = 0;
<a name="l01019"></a>01019 
<a name="l01027"></a>01027         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearFrameBuffer(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffers, 
<a name="l01028"></a>01028             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#7f8a06f2a9dd645417c36b560f496c1a">ColourValue::Black</a>, 
<a name="l01029"></a>01029             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> depth = 1.0f, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> stencil = 0) = 0;
<a name="l01039"></a>01039         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getHorizontalTexelOffset(<span class="keywordtype">void</span>) = 0;
<a name="l01049"></a>01049         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getVerticalTexelOffset(<span class="keywordtype">void</span>) = 0;
<a name="l01050"></a>01050 
<a name="l01059"></a>01059         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMinimumDepthInputValue(<span class="keywordtype">void</span>) = 0;
<a name="l01068"></a>01068         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMaximumDepthInputValue(<span class="keywordtype">void</span>) = 0;
<a name="l01074"></a><a class="code" href="classOgre_1_1RenderSystem.html#f6ac17b9d69f3bced84094a7b380611e">01074</a>         <span class="keywordtype">void</span> setCurrentPassIterationCount(<span class="keyword">const</span> <span class="keywordtype">size_t</span> count) { mCurrentPassIterationCount = count; }
<a name="l01075"></a>01075 
<a name="l01080"></a><a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html">01080</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html" title="Defines a listener on the custom events that this render system can raise.">Listener</a>
<a name="l01081"></a>01081         {
<a name="l01082"></a>01082         <span class="keyword">public</span>:
<a name="l01083"></a><a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html#2ccefd2fe4eb8ca096e8ec7efbefc413">01083</a>             <a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html" title="Defines a listener on the custom events that this render system can raise.">Listener</a>() {}
<a name="l01084"></a><a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html#92f2b3702187d4893f0a28993510f759">01084</a>             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html" title="Defines a listener on the custom events that this render system can raise.">Listener</a>() {}
<a name="l01085"></a>01085 
<a name="l01091"></a>01091             <span class="keyword">virtual</span> <span class="keywordtype">void</span> eventOccurred(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; eventName, 
<a name="l01092"></a>01092                 <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a>* parameters = 0) = 0;
<a name="l01093"></a>01093         };
<a name="l01107"></a>01107         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addListener(Listener* l);
<a name="l01110"></a>01110         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeListener(Listener* l);
<a name="l01111"></a>01111 
<a name="l01116"></a><a class="code" href="classOgre_1_1RenderSystem.html#8f3b7402316e7162fb5778235fc6e2f2">01116</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a>&amp; getRenderSystemEvents(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mEventNames; }
<a name="l01117"></a>01117 
<a name="l01134"></a>01134         <span class="keyword">virtual</span> <span class="keywordtype">void</span> preExtraThreadsStarted() = 0;
<a name="l01135"></a>01135 
<a name="l01136"></a>01136         <span class="comment">/* Tell the rendersystem to perform any tasks it needs to directly</span>
<a name="l01137"></a>01137 <span class="comment">            after other threads which might access the rendering API are registered.</span>
<a name="l01138"></a>01138 <span class="comment">        @see RenderSystem::preExtraThreadsStarted</span>
<a name="l01139"></a>01139 <span class="comment">        */</span>
<a name="l01140"></a>01140         <span class="keyword">virtual</span> <span class="keywordtype">void</span> postExtraThreadsStarted() = 0;
<a name="l01141"></a>01141         
<a name="l01154"></a>01154         <span class="keyword">virtual</span> <span class="keywordtype">void</span> registerThread() = 0;
<a name="l01155"></a>01155             
<a name="l01159"></a>01159         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unregisterThread() = 0;
<a name="l01160"></a>01160     <span class="keyword">protected</span>:
<a name="l01161"></a>01161 
<a name="l01162"></a>01162         
<a name="l01164"></a><a class="code" href="classOgre_1_1RenderSystem.html#5ea599be4da15690178a9aca2261e992">01164</a>         <a class="code" href="namespaceOgre.html#2551e2d3573c437f3beccf7d3ac7a45e">RenderTargetMap</a> mRenderTargets;
<a name="l01166"></a><a class="code" href="classOgre_1_1RenderSystem.html#69c3a5daa75ce78fd56226941f1c8126">01166</a>         <a class="code" href="namespaceOgre.html#eacbf68563f1c1e5660c4399d398608c">RenderTargetPriorityMap</a> mPrioritisedRenderTargets;
<a name="l01168"></a><a class="code" href="classOgre_1_1RenderSystem.html#398254faea8f9fe6454abb38eee5b3f4">01168</a>         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a> * mActiveRenderTarget;
<a name="l01170"></a><a class="code" href="classOgre_1_1RenderSystem.html#e98e8807b322bccf0eb160afdb54537e">01170</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> mActiveVertexGpuProgramParameters;
<a name="l01171"></a><a class="code" href="classOgre_1_1RenderSystem.html#5b9972dd9bb47c45732ad1c82c55817d">01171</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> mActiveFragmentGpuProgramParameters;
<a name="l01172"></a>01172 
<a name="l01173"></a>01173         <span class="comment">// Texture manager</span>
<a name="l01174"></a>01174         <span class="comment">// A concrete class of this will be created and</span>
<a name="l01175"></a>01175         <span class="comment">// made available under the TextureManager singleton,</span>
<a name="l01176"></a>01176         <span class="comment">// managed by the RenderSystem</span>
<a name="l01177"></a><a class="code" href="classOgre_1_1RenderSystem.html#80f14e152184bddc68f8ae05bcefb3be">01177</a>         <a class="code" href="classOgre_1_1TextureManager.html" title="Class for loading &amp;amp; managing textures.">TextureManager</a>* mTextureManager;
<a name="l01178"></a>01178 
<a name="l01180"></a><a class="code" href="classOgre_1_1RenderSystem.html#522d538a97121d370fcecbc63f4330e6">01180</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* mCapabilities;
<a name="l01181"></a>01181 
<a name="l01182"></a>01182         <span class="comment">// Active viewport (dest for future rendering operations)</span>
<a name="l01183"></a><a class="code" href="classOgre_1_1RenderSystem.html#122f2e8cbddd313582f05677f5a26b1c">01183</a>         <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* mActiveViewport;
<a name="l01184"></a>01184 
<a name="l01185"></a><a class="code" href="classOgre_1_1RenderSystem.html#60ce74b29c3e1c9e11041029117a85ad">01185</a>         <a class="code" href="namespaceOgre.html#c173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mCullingMode;
<a name="l01186"></a>01186 
<a name="l01187"></a><a class="code" href="classOgre_1_1RenderSystem.html#c0df5de57fa3480f74c98c65a7211a30">01187</a>         <span class="keywordtype">bool</span> mVSync;
<a name="l01188"></a><a class="code" href="classOgre_1_1RenderSystem.html#7c4ad7937f023a43ee43473750d2bfe9">01188</a>         <span class="keywordtype">bool</span> mWBuffer;
<a name="l01189"></a>01189 
<a name="l01190"></a><a class="code" href="classOgre_1_1RenderSystem.html#039fe39c5374812e776c677404f00898">01190</a>         <span class="keywordtype">size_t</span> mBatchCount;
<a name="l01191"></a><a class="code" href="classOgre_1_1RenderSystem.html#a735bd71b568209de09adfa86b737737">01191</a>         <span class="keywordtype">size_t</span> mFaceCount;
<a name="l01192"></a><a class="code" href="classOgre_1_1RenderSystem.html#0716f3fd1349f7c4399d805d03e4c394">01192</a>         <span class="keywordtype">size_t</span> mVertexCount;
<a name="l01193"></a>01193 
<a name="l01195"></a><a class="code" href="classOgre_1_1RenderSystem.html#a40237e355676bb7024fccd8699eee96">01195</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mManualBlendColours[<a class="code" href="OgreConfig_8h.html#1c5fd80e6e0f2f85d6facbe1ec8eb5a4" title="Define max number of texture layers allowed per pass on any card.">OGRE_MAX_TEXTURE_LAYERS</a>][2];
<a name="l01196"></a>01196 
<a name="l01197"></a><a class="code" href="classOgre_1_1RenderSystem.html#df3d0f2e777d97e2032ef01cb1b3ecee">01197</a>         <span class="keywordtype">bool</span> mInvertVertexWinding;
<a name="l01198"></a>01198 
<a name="l01200"></a><a class="code" href="classOgre_1_1RenderSystem.html#9a071dab9e9b40bfde6d2e85cb363274">01200</a>         <span class="keywordtype">size_t</span> mDisabledTexUnitsFrom;
<a name="l01201"></a>01201 
<a name="l01203"></a><a class="code" href="classOgre_1_1RenderSystem.html#179ea5dd6f5b8f1430ebc10dd582fdb8">01203</a>         <span class="keywordtype">size_t</span> mCurrentPassIterationCount;
<a name="l01204"></a>01204 
<a name="l01209"></a>01209         <span class="keywordtype">bool</span> updatePassIterationRenderState(<span class="keywordtype">void</span>);
<a name="l01210"></a>01210 
<a name="l01212"></a><a class="code" href="classOgre_1_1RenderSystem.html#b213f4023f49f961377aa52c8c11acc3">01212</a>         <a class="code" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a> mEventNames;
<a name="l01213"></a>01213 
<a name="l01215"></a>01215         <span class="keyword">virtual</span> <span class="keywordtype">void</span> fireEvent(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a>* params = 0);
<a name="l01216"></a>01216 
<a name="l01217"></a><a class="code" href="classOgre_1_1RenderSystem.html#a1072468272ad965dbc651aa8fc09031">01217</a>         <span class="keyword">typedef</span> std::list&lt;Listener*&gt; ListenerList;
<a name="l01218"></a><a class="code" href="classOgre_1_1RenderSystem.html#d0cf554e93303c9305d3446eb2efb411">01218</a>         ListenerList mEventListeners;
<a name="l01219"></a>01219 
<a name="l01220"></a><a class="code" href="classOgre_1_1RenderSystem.html#b56b367e25b74e95e6ad773a282c494d">01220</a>         <span class="keyword">typedef</span> std::list&lt;HardwareOcclusionQuery*&gt; HardwareOcclusionQueryList;
<a name="l01221"></a><a class="code" href="classOgre_1_1RenderSystem.html#7bb1437e3f40cda2bb1495b51ba88791">01221</a>         HardwareOcclusionQueryList mHwOcclusionQueries;
<a name="l01222"></a>01222         
<a name="l01223"></a><a class="code" href="classOgre_1_1RenderSystem.html#69173bf6d120d39f702c5de9e0815218">01223</a>         <span class="keywordtype">bool</span> mVertexProgramBound;
<a name="l01224"></a><a class="code" href="classOgre_1_1RenderSystem.html#79ba9d85873031a65a9548e65e50109d">01224</a>         <span class="keywordtype">bool</span> mFragmentProgramBound;
<a name="l01225"></a>01225         
<a name="l01226"></a>01226 
<a name="l01227"></a>01227 
<a name="l01228"></a>01228     };
<a name="l01229"></a>01229 }
<a name="l01230"></a>01230 
<a name="l01231"></a>01231 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:55 2008
</p>
</body>
</html>
